package me.nvus.nvus_prison_setup.Configs;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.plugin.java.JavaPlugin;

public class SettingsMenu implements Listener {
    private final JavaPlugin plugin;
    private final ConfigManager configManager;

    public SettingsMenu(JavaPlugin plugin, ConfigManager configManager) {
        this.plugin = plugin;
        this.configManager = configManager;
        plugin.getServer().getPluginManager().registerEvents(this, plugin);
    }

    public void openSettingsMenu(Player player) {
        Inventory inv = Bukkit.createInventory(null, 9, ChatColor.DARK_GREEN + "NVus Prison Settings");

        // Toggle AutoPickup
        ItemStack toggleAutoPickup = new ItemStack(Material.HOPPER);
        ItemMeta metaAutoPickup = toggleAutoPickup.getItemMeta();
        metaAutoPickup.setDisplayName(ChatColor.GREEN + "Toggle AutoPickup");
        toggleAutoPickup.setItemMeta(metaAutoPickup);
        inv.setItem(3, toggleAutoPickup);

        // Toggle AutoSwitch
        ItemStack toggleAutoSwitch = new ItemStack(Material.LEVER);
        ItemMeta metaAutoSwitch = toggleAutoSwitch.getItemMeta();
        metaAutoSwitch.setDisplayName(ChatColor.GREEN + "Toggle AutoSwitch");
        toggleAutoSwitch.setItemMeta(metaAutoSwitch);
        inv.setItem(4, toggleAutoSwitch);

        // Reload Configurations
        ItemStack reloadConfigs = new ItemStack(Material.BOOK);
        ItemMeta metaReloadConfigs = reloadConfigs.getItemMeta();
        metaReloadConfigs.setDisplayName(ChatColor.GREEN + "Reload Configs");
        reloadConfigs.setItemMeta(metaReloadConfigs);
        inv.setItem(5, reloadConfigs);

        player.openInventory(inv);
    }

    @EventHandler
    public void onInventoryClick(InventoryClickEvent event) {
        if (!event.getView().getTitle().equals(ChatColor.DARK_GREEN + "Settings Menu")) return;
        event.setCancelled(true);

        Player player = (Player) event.getWhoClicked();
        ItemStack clickedItem = event.getCurrentItem();
        if (clickedItem == null || !clickedItem.hasItemMeta()) return;

        String displayName = clickedItem.getItemMeta().getDisplayName();
        if (displayName.equals(ChatColor.GREEN + "Toggle AutoPickup")) {
            // Toggle AutoPickup logic here
        } else if (displayName.equals(ChatColor.GREEN + "Toggle AutoSwitch")) {
            // Toggle AutoSwitch logic here
        } else if (displayName.equals(ChatColor.GREEN + "Reload Configs")) {
            configManager.reloadConfig("config.yml");
            configManager.reloadConfig("auto_switch.yml");
            configManager.reloadConfig("banned_items.yml");
            player.sendMessage(ChatColor.GREEN + "Configuration files reloaded.");
        }
    }
}
